VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3750
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3750
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picDest 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   1575
      Left            =   2400
      ScaleHeight     =   101
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   141
      TabIndex        =   6
      Top             =   2040
      Width           =   2175
   End
   Begin VB.PictureBox picSource 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   120
      ScaleHeight     =   101
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   141
      TabIndex        =   5
      Top             =   2040
      Width           =   2175
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   1920
      TabIndex        =   4
      Top             =   1560
      Width           =   975
   End
   Begin VB.CheckBox chkRandomLines 
      Caption         =   "Random Lines"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1455
   End
   Begin VB.CheckBox chkDrawGrid 
      Caption         =   "Draw Grid"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   1215
   End
   Begin VB.TextBox txtString 
      Height          =   285
      Left            =   600
      TabIndex        =   1
      Text            =   "TEST STRING"
      Top             =   120
      Width           =   3975
   End
   Begin VB.Label lblParameters 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   120
      TabIndex        =   7
      Top             =   1200
      Width           =   45
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Text:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   360
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    Randomize
End Sub

Private Sub cmdGo_Click()
Dim wid As Integer
Dim hgt As Integer
Dim src_bm As Picture
Dim x As Integer
Dim y As Integer
Dim mag0 As Single
Dim per0 As Single
Dim mag1 As Single
Dim per1 As Single
Dim mag2 As Single
Dim per2 As Single
Dim ix As Integer
Dim iy As Integer
Dim dx0 As Single
Dim dy0 As Single
Dim dx1 As Single
Dim dy1 As Single
Dim r As Integer
Dim g As Integer
Dim b As Integer
Dim r00 As Integer
Dim g00 As Integer
Dim b00 As Integer
Dim r01 As Integer
Dim g01 As Integer
Dim b01 As Integer
Dim r10 As Integer
Dim g10 As Integer
Dim b10 As Integer
Dim r11 As Integer
Dim g11 As Integer
Dim b11 As Integer
Dim clr As OLE_COLOR
Dim i As Integer

    ' Draw the source image.
    wid = picSource.ScaleWidth
    hgt = picSource.ScaleHeight

    picSource.Cls
    picDest.Cls

    ' Draw the text.
    picSource.CurrentX = (wid - picSource.TextWidth(txtString.Text)) / 2
    picSource.CurrentY = (hgt - picSource.TextHeight(txtString.Text)) / 2
    picSource.Print txtString.Text

    ' Draw a grid if desired.
    If chkDrawGrid.Value = vbChecked Then
        For x = 0 To wid Step 20
            For y = 0 To hgt Step 20
                picSource.Line (x, 0)-(x, hgt), vbRed
                picSource.Line (0, y)-(wid, y), vbRed
            Next y
        Next x
    End If

    mag0 = Random(2, 6)
    per0 = Random(20, 30)
    mag1 = Random(3, 6)
    per1 = Random(20, 40)
    mag2 = Random(1, 3)
    per2 = Random(10, 20)
    lblParameters.Caption = _
        mag0 & ", " & per0 & "; " & _
        mag1 & ", " & per1 & "; " & _
        mag2 & ", " & per2

    ' Make the destination bitmap.
    For x = 0 To wid - 1
        For y = 0 To hgt - 1
            ' Find source (x, y).
            Dim sx As Single
            Dim sy As Single
            InvertXY mag0, per0, mag1, per1, mag2, per2, x, y, sx, sy

            ' Interpolate.
            ix = Int(sx)
            iy = Int(sy)

            If ix < 0 Or ix >= wid - 1 Or _
               iy < 0 Or iy >= hgt - 1 _
            Then
                picDest.PSet (x, y), vbWhite
            Else
                ReverseRGB picSource.Point(ix, iy), r00, g00, b00
                ReverseRGB picSource.Point(ix + 1, iy), r10, g10, b10
                ReverseRGB picSource.Point(ix, iy + 1), r01, g01, b01
                ReverseRGB picSource.Point(ix + 1, iy + 1), r11, g11, b11
                
                dx0 = sx - ix
                dy0 = sy - iy
                dx1 = 1 - dx0
                dy1 = 1 - dy0
                r = dy1 * (dx1 * r00 + dx0 * r10) + _
                    dy0 * (dx1 * r01 + dx0 * r11)
                g = dy1 * (dx1 * g00 + dx0 * g10) + _
                    dy0 * (dx1 * g01 + dx0 * g11)
                b = dy1 * (dx1 * b00 + dx0 * b10) + _
                    dy0 * (dx1 * b01 + dx0 * b11)
                    
                picDest.PSet (x, y), RGB(r, g, b)
            End If
        Next y
    Next x

    ' Draw random lines if desired.
    If chkRandomLines.Value = vbChecked Then
        For i = 1 To 10
            picDest.Line (Random(0, wid), 0)-(Random(0, wid), hgt), vbBlack
            picDest.Line (Random(0, wid), 0)-(Random(0, wid), hgt), vbWhite
        Next i
    End If
End Sub

Private Sub InvertXY(ByVal mag0 As Single, ByVal per0 As Single, ByVal mag1 As Single, ByVal per1 As Single, ByVal mag2 As Single, ByVal per2 As Single, ByVal x As Integer, ByVal y As Integer, ByRef sx As Single, ByRef sy As Single)
Const PI As Single = 3.14159265

    sx = x - mag0 * Cos(y * PI / per0)
    sy = y - mag1 * Sin(x * PI / per1) - mag2 * Sin(x * PI / per2)
End Sub

Public Sub ReverseRGB(ByVal Value As Long, Red As Integer, Green As Integer, Blue As Integer)
Dim lngRed As Long
Dim lngGreen As Long
Dim lngBlue As Long

    lngBlue = Int(Value / 65536)
    lngGreen = Int((Value - (65536 * lngBlue)) / 256)
    lngRed = Value - ((lngBlue * 65536) + (lngGreen * 256))
    Red = lngRed
    Green = lngGreen
    Blue = lngBlue
End Sub

Private Function Random(ByVal min_v As Single, ByVal max_v As Single) As Single
    Random = min_v + Rnd * (max_v - min_v)
End Function
